
Rem
bbdoc: state ON
EndRem
Const UIButtonStateOn	:Int = 1

Rem
bbdoc: state OFF
EndRem
Const UIButtonStateOff	:Int = 0

Rem
bbdoc: UIButton
EndRem
Type UIButton Extends UIControl

	Field _title:String

	Field _onoff:Byte
	Field _state:Byte

	Field _hover:Byte
	
	'------
	'create
	'------
	
	Function Create:UIButton( frame_:StdRect )
		Local ret_:UIButton = New UIButton
			ret_.initWithFrame(frame_)
		Return ret_
	EndFunction
	
	Method initWithFrame( frame_:StdRect )
		Super.initWithFrame(frame_)
		
		setTitle("")
		setOnOff(NO)
		setState(UIButtonStateOff)
	EndMethod
	
	'----------
	'accsessors
	'----------
	
	Method setTitle( title_:String )
		_title = title_
	EndMethod
	
	Method getTitle:String()
		Return _title
	EndMethod
	
	Method setOnOff( onoff_:Byte )
		_onoff = onoff_
	EndMethod
	
	Method getOnOff:Byte()
		Return _onoff
	EndMethod
	
	Method setState( state_:Byte )
		_state = state_
	EndMethod
	
	Method getState:Byte()
		Return _state
	EndMethod

	'------
	'events
	'------
	
	Method mouseEntered( event:UIEvent )
		_hover = 1
	EndMethod
	
	Method mouseLeft( event:UIEvent )
		_hover = 0
	EndMethod
	
	Method leftMouseDown( event:UIEvent )
		_hover = 2
	EndMethod
	
	Method leftMouseUp( event:UIEvent )
		_hover = 1
				
		callAction()
		If getOnOff() setState(1-getState())
	EndMethod
	
	'------
	'render
	'------
	
	Method render()
		UIStyle.getCurrentStyle().renderButton(Self)
		'DrawText("test", _abs_frame.size.width/2.0-TextWidth("test")/2.0, _abs_frame.size.height/2.0-TextHeight("test")/2.0)
	EndMethod
EndType