
Rem
bbdoc: Set the viewport to a given frame.
EndRem
Function UISetViewport( frame_:StdRect )
	SetViewport(frame_.origin.x, frame_.origin.y, frame_.size.width, frame_.size.height)
EndFunction

Rem
bbdoc: Throws a exception with the UI.mod prefix
about: The prefix is declared in ui.const
EndRem
Function UIError( message_:String )
	Throw "["+UI_EXCEPTION_PREFIX+"] "+message_
EndFunction

Const UI_EXCEPTION_PREFIX:String = "UI 0.1b"

Rem
bbdoc: Returns UI's NullView
EndRem
Function UIGetNullView:UINullView()
	Return UI.getInstance().getNullView()
EndFunction